Subject: Re: bug#35613: Cursor returns to wrong article!

From: "Basil L. Contovounesios" <[email-masked]>
Date: Tue, 07 May 2019 14:10:47 +0100

tags 35613 + patch
quit

積丹尼 Dan Jacobson <[email-masked]> writes:

> I discovered a massive bug. A bug that could cause the user to lose mail.
>
> In the *Summary* buffer use a few
>  <down> [next-line]
> until the cursor is upon call it, article A.
>  <return> [gnus-summary-scroll-up]
>  <down> [next-line] (once or more)
>  <return> [gnus-summary-scroll-up]
>  <tab> [gnus-summary-widget-forward]
>  = [gnus-article-read-summary-keys]
> Even though the ">" arrow at left and the underline are on a different article,
> but the cursor now returns to Article A!!
>
> Now if he hits e.g., the E key, he will mark the wrong article!
> Or if he forwards it to his grandmother, she will die because he
> forwarded the wrong article and she had a heart attack. See, gnus kills people!
>
> Sure you will argue that that is a feature, however I used the same
>  <return> [gnus-summary-scroll-up]
> twice and for no good reason you remember the first one.
>
> Gnus v5.13
> GNU Emacs 26.1 (build 2, x86_64-pc-linux-gnu, GTK+ Version 3.24.4)
>  of 2019-02-03, modified by Debian

This is the user option switch-to-buffer-preserve-window-point in
action.  If you customise it to nil, the behaviour you describe should
go away.

This is why Elisp programs should usually use pop-to-buffer et
al. instead of switch-to-buffer et al.  The following patch should fix
that for this case:

>From 1d7a51d2e3a1c3d5caa77587b3e612feda8bdd59 Mon Sep 17 00:00:00 2001
From: "Basil L. Contovounesios" <[email-masked]>
Date: Tue, 7 May 2019 13:46:22 +0100
Subject: [PATCH] Fix gnus-summary-expand-window placement of point

* lisp/gnus/gnus-win.el (gnus-configure-frame): Replace
switch-to-buffer with pop-to-buffer-same-window to avoid messing
with point. (bug#35613)
---
 lisp/gnus/gnus-win.el | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/lisp/gnus/gnus-win.el b/lisp/gnus/gnus-win.el
index 5f7154c545..c6469f4937 100644
--- a/lisp/gnus/gnus-win.el
+++ b/lisp/gnus/gnus-win.el
@@ -284,7 +284,7 @@ gnus-configure-frame
                 ;; from a hard-dedicated frame, it creates (and
                 ;; configures) a new frame, leaving the dedicated frame alone.
                 (pop-to-buffer buf))
-               (t (switch-to-buffer buf)))))
+               (t (pop-to-buffer-same-window buf)))))
 	  (when (memq 'frame-focus split)
 	    (setq gnus-window-frame-focus window))
 	  ;; We return the window if it has the `point' spec.
-- 
2.20.1

I'll push it to master in a week or so if there are no objections before
then.

Thanks,

-- 
Basil